# Copyright (c) 2017 BaseSoft B.V.
# See LICENSE for details.
from basesoft.web.core.util.db import DatabaseSession
from pvcycle.core.models import PvcMemberLicense

sa_session = DatabaseSession().Session


def set_company_locale():
    members = sa_session.query(PvcMemberLicense).all()
    for member in members:
        if member.company.contact_person is None:
            continue

        if member.company.correspondence_locale is None:
            locale = member.company.invoice_person.preferred_locale
            print 'Setting correspondence locale for member %s to %s' % (member, locale)
            member.company.correspondence_locale = locale
            sa_session.add(member.company)

        if member.temp_company is not None and member.temp_company.correspondence_locale is None:
            member.temp_company.correspondence_locale = locale
            sa_session.add(member.temp_company)


if __name__ == "__main__":
    sa_session.begin()
    try:
        set_company_locale()
        sa_session.commit()
    except Exception, e:
        sa_session.rollback()
        raise e
