'''
Created on Jul 11, 2014

@author: rado
'''
from iqportal.iqube.core.db_sync import AbstractConfigurableWidget

from django.utils.translation import ugettext as _

class PvcOrderResultWidget(AbstractConfigurableWidget):
    cube = 'PvcOrderCube'
    category = 'PVC Report'
    datasource = 'PvcOrderData'
    label = _('Order result')

    def config(self):

        return {
            "reporter": "pvcycle.order.PvcOrderResultReporter",
            "show_last_aggregation_update": True,
            "category": "Order",
            "has_quick_filter": True,
            "has_drill_through": False,
            "show_hide_empty": True,
            "transposable": True,
            "label": "Order result",
            "show_excel_export": True,
            "has_drill_position": False,
            "cube": "PvcOrderCube",
            "has_graph": True,
            "id": 1,
            "table_object_name": "datatablecube",
            "table_module": "iqreport_graph_datatablecube",
            "has_table": True,
            "has_hierarchy_names": True,
            "graph_config": {},
            "has_drill_replace": False,

            "dimensions": [{
                "caption": "TBS",
                "available_on_rows": True,
                "show_named_sets": False,
                "has_select_as_group": True,
                "available_as_split_by": False,
                "required": False,
                "show_full_caption": True,
                "available_as_slicer": True,
                "fancy_select_module": "iq_fancyselect",
                "available_on_columns": True,
                "show_calculated_members": False,
                "children": [                {
                    "unique_name": "[TBS].[TBS]",
                    "has_children_available": True,
                    "caption": "TBS",
                    "has_all_member_available": True,
                    "show_members": True,
                    "method_argument": "[TBS].[TBS]",
                    "method": "get_level_members"
                }]
                }, {
                    "caption": "Member",
                    "available_on_rows": True,
                    "show_named_sets": False,
                    "has_select_as_group": True,
                    "available_as_split_by": False,
                    "required": False,
                    "available_as_slicer": True,
                    "fancy_select_module": "iq_fancyselect",
                    "available_on_columns": True,
                    "show_calculated_members": False,
                    "children": [{
                        "unique_name": "[Member].[Member]",
                        "has_children_available": True,
                        "caption": "Member",
                        "has_all_member_available": True,
                        "show_members": True,
                        "method_argument": "[Member].[Member]",
                        "method": "get_level_members",
                    }]
                }, {
                    "caption": "TBS Member",
                    "available_on_rows": True,
                    "show_named_sets": False,
                    "has_select_as_group": True,
                    "available_as_split_by": False,
                    "required": False,
                    "available_as_slicer": True,
                    "fancy_select_module": "iq_fancyselect",
                    "available_on_columns": True,
                    "show_calculated_members": False,
                        "children": [{
                            "unique_name": "[TBS Member].[TBS]",
                            "has_all_member_available": True,
                            "has_children_available": False,
                            "show_members": False,
                            "caption": "TBS",
                            "method_argument": "[TBS Member].[TBS]",
                            "method": "get_level_members",
                        },
                            {
                            "unique_name": "[TBS Member].[Member]",
                            "has_all_member_available": True,
                            "has_children_available": True,
                            "show_members": True,
                            "caption": "Member",
                            "method_argument": "[TBS Member].[Member]",
                            "method": "get_level_members",
                        }]
                },{
                "caption": "GL Account",
                "available_on_rows": True,
                "show_named_sets": False,
                "has_select_as_group": True,
                "available_as_split_by": False,
                "required": False,
                "show_full_caption": True,
                "available_as_slicer": True,
                "fancy_select_module": "iq_fancyselect",
                "available_on_columns": True,
                "show_calculated_members": False,
                "children": [                {
                    "unique_name": "[GL Account].[GL Account]",
                    "has_children_available": True,
                    "caption": "GL Account",
                    "has_all_member_available": True,
                    "show_members": True,
                    "method_argument": "[GL Account].[GL Account]",
                    "method": "get_level_members"
                }]
                }, {
                "caption": "Invoice Type",
                "available_on_rows": True,
                "show_named_sets": False,
                "has_select_as_group": True,
                "available_as_split_by": False,
                "required": False,
                "show_full_caption": True,
                "available_as_slicer": True,
                "fancy_select_module": "iq_fancyselect",
                "available_on_columns": True,
                "show_calculated_members": False,
                "children": [                {
                    "unique_name": "[Invoice Type].[Invoice Type]",
                    "has_children_available": True,
                    "caption": "Invoice Type",
                    "has_all_member_available": True,
                    "show_members": True,
                    "method_argument": "[Invoice Type].[Invoice Type]",
                    "method": "get_level_members"
                }]
                },{
                "caption": "Order Type",
                "available_on_rows": True,
                "show_named_sets": False,
                "has_select_as_group": True,
                "available_as_split_by": False,
                "required": False,
                "available_as_slicer": True,
                "fancy_select_module": "iq_fancyselect",
                "available_on_columns": True,
                "show_calculated_members": False,
                "children": [                {
                    "unique_name": "[Order Type].[Order Type]",
                    "has_children_available": True,
                    "caption": "Order Type",
                    "has_all_member_available": True,
                    "show_members": True,
                    "method_argument": "[Order Type].[Order Type]",
                    "method": "get_level_members"
                }]
                },
                {
                "caption": "Submit Period",
                "available_on_rows": True,
                "show_named_sets": False,
                "has_select_as_group": True,
                "available_as_split_by": False,
                "required": False,
                "show_full_caption": True,
                "available_as_slicer": True,
                "fancy_select_module": "level_filter_fancy_select",
                "fancy_select_optionsRpcUrl": 'iqportal.iqube.core.IQubeRPCHandler',
                "fancy_select_RpcMethod": 'get_time_children',

                "available_on_columns": True,
                "show_calculated_members": False,
                "children": [{
                    "unique_name": "[Submit Period.Quarter].[Year]",
                    "has_children_available": False,
                    "caption": "Quarter",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Submit Period.Quarter].[Year]",
                    "method": "get_level_members",
                    "has_drill_enabled": True,
                }, {
                    "unique_name": "[Submit Period.WeekISO8601].[Year]",
                    "has_children_available": False,
                    "caption": "Week",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Submit Period.WeekISO8601].[Year]",
                    "method": "get_level_members",
                    "has_drill_enabled": True,
                }, ]

                }, {
                "caption": "Payment Period",
                "available_on_rows": True,
                "show_named_sets": False,
                "has_select_as_group": True,
                "available_as_split_by": False,
                "required": False,
                "show_full_caption": True,
                "available_as_slicer": True,
                "fancy_select_module": "level_filter_fancy_select",
                "fancy_select_optionsRpcUrl": 'iqportal.iqube.core.IQubeRPCHandler',
                "fancy_select_RpcMethod": 'get_time_children',

                "available_on_columns": True,
                "show_calculated_members": False,
                "children": [{
                    "unique_name": "[Payment Period.Quarter].[Year]",
                    "has_children_available": False,
                    "caption": "Quarter",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Payment Period.Quarter].[Year]",
                    "method": "get_level_members",
                    "has_drill_enabled": True,
                }, {
                    "unique_name": "[Payment Period.WeekISO8601].[Year]",
                    "has_children_available": False,
                    "caption": "Week",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Payment Period.WeekISO8601].[Year]",
                    "method": "get_level_members",
                    "has_drill_enabled": True,
                },]

                }, {
                "caption": "Payment Method",
                "available_on_rows": True,
                "show_named_sets": False,
                "has_select_as_group": True,
                "available_as_split_by": False,
                "required": False,
                "available_as_slicer": True,
                "fancy_select_module": "iq_fancyselect",
                "available_on_columns": True,
                "show_calculated_members": False,
                "children": [                {
                    "unique_name": "[Payment Method].[Payment Method]",
                    "has_children_available": True,
                    "caption": "Invoice Type",
                    "has_all_member_available": True,
                    "show_members": True,
                    "method_argument": "[Payment Method].[Payment Method]",
                    "method": "get_level_members"
                }]
                }, {
                "caption": "Measures",
                "available_on_rows": True,
                "show_named_sets": False,
                "has_select_as_group": False,
                "available_as_split_by": False,
                "required": False,
                "available_as_slicer": True,
                "fancy_select_module": "iq_fancyselect",
                "available_on_columns": True,
                "show_calculated_members": False,
                "children": [
                {
                    "unique_name": "[Measures].[MeasuresLevel]",
                    "has_children_available": True,
                    "caption": "MeasuresLevel",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Measures].[MeasuresLevel]",
                    "method": "get_level_members"
                }]
                },
            ],
        }

    def applied_filters(self):
        return {
            "dimensions": {
                "TBS": "0",
                "Member": "1",
                "TBS Member": "2",
                "GL Account": "3",
                "Invoice Type": "4",
                "Order Type": "5",
                "Submit Period": "6",
                "Payment Period": "7",
                "Payment Method": "8",
                "Measures": "9",
            },


            "axes_0": "",
            "axes_1": "",
            "axes_2": "",
            "axes_3": "",
            "axes_4": "",
            "axes_5": "",
            "axes_6": "",
            "axes_7": "",
            "axes_8": "",
            "axes_9": "columns",

            "dimension_0": [],
            "dimension_1": [],
            "dimension_2": [],
            "dimension_3": [],
            "dimension_4": [],
            "dimension_5": [],
            "dimension_6": [],
            "dimension_7": [],
            "dimension_8": [],
            "dimension_9": ["[Measures].[Amount (excl. vat)]"],

            "column_order": [
                "Measures",
            ],
            "row_order": [
            ],

            "show_table": True,
            "show_slicers": True,

            "initialRefresh": False,

        }
